#ifndef AbstractInterruptHandler_h
#define AbstractInterruptHandler_h

#include <Arduino.h>

class AbstractInterruptHandler {
public:

    AbstractInterruptHandler() {
        enabled = true;
    }
    
    virtual void handleInterrupt(byte intPin) = 0;
    
    virtual bool wantInterrupt(byte intPin) {
        return isEnabled();
    }
    
    virtual void onAttach(byte intPin) = 0;

    virtual void onDetach(byte intPin) = 0;

    bool isEnabled() {
        return enabled;
    }

    void setEnabled(bool en) {
        enabled = en;
    }
    
private:
    bool enabled;
};

#endif
