#ifndef TimerTaskScheduler_h
#define	TimerTaskScheduler_h

#include "Timer.h"
#include "TimerTask.h"
#include "Map.h"

class TimerTaskEntry;

class TimerTaskScheduler : public Timer {
public:
    TimerTaskScheduler(byte _pin, long _resolution);
    
    void scheduleTask(TimerTask * task, long firstInterval, long interval);
    void scheduleTask(TimerTask * task, long interval);
    void scheduleTaskSingle(TimerTask * task, long interval);
    void removeTask(TimerTask * task);

    void handleInterrupt(byte intPin);
    void onAttach(byte intPin);
    void onDetach(byte intPin);
    
private:
    long resolution;
    long processTime;
    
    long getProcessTime();
    
    Map<long, TimerTaskEntry *> * taskMap;

    static void process(long k, TimerTaskEntry * entry, void * data);
    static void addToDelete(long k, TimerTaskEntry * entry, void * data);
    static void deleteEntry(long k, void * data);
    
    static long currentTaskId;

};

#endif
